# DCP cheat sheet

It's 🐢 all the way down. Reverse-enegineered by @marcan42 

ENDPOINT LAYER
----------------

Endpoint 0x37

DCPMessages are 64 bits

DCPEP_SetShmem:
	DVA [16, 63]
	FLAG [4, 7] == 4
	TYPE [0, 3] == 0

DCPEp_InitComplete:
	TYPE = [0, 3] == 1

DCPEp_Message (
	[0, 3]: type == 2
	6: ACK
	[8, 11]: context
	[16, 31]: offset
	[32, 63]: len
)

sent on lower dword. upper dword is just the EP number.

Multiple channels

Call CMD 0, 0x8000

Recv CB 0x6000, 0x8000

To initiailize, allocate 0x100000 of memory mapped to DCP dart and then DCPEp_SetShmem(DVA=shmem_dva), work until getting a DCPEp_InitComplete

PACKET LAYER
--------------

Sending
.........

dcpep.call has the outer structure of a dcp packet

struct dcp_packet {
	char tag[4]; // little endian, e.g. "121D"
	uint32_t in_len;
	uint32_t out_len;
	uint8_t inbuf[];
}

written to DCP shmem's buffer's offset and offset advanced by `data_size = len(packet) + out_len` aligned to 0x40

then we send DCPEp_Msg(LEN=data_size, OFF=offset, CTX=ctx, ACK=0)
where CTX is either CB or CMD depending on direction

work until complete

read out_len bytes from out_addr = bug + off + in_len + 12

Receiving
............

Data is at buf + off + in_len, of type dcp_packet again
write resp to out addr
send DCPEp_Msg(CTX=ctx, ACK=1)

MESSAGE LAYER
------------------

out_len is sizeof(out_struct)

struct dcp_in_struct {
	u8 inputs[]; // each aligned to min(4, len) maybe
	bool nullables[]; // one byte for each pointer
	u8 padding[]; // up to nearest word
};

struct dcp_out_struct {
	u8 outputs[]; // each aligned to min(4, len) maybe
	u8 padding[]; // up to nearest word
};

Many calls are defined and filled out in the obvious way, see ipc.py for a listing.
